#include <stdio.h>
#include <signal.h>

/* Le père crée trois processus fils : Good (pg), Bad (pb), et Ugly (pu).
   Normalement, le père et les trois fils sont dans le même groupe de
   processus. Par contre, ici on mettra Bad et Ugly dans un group à eux
   (et avec pb comme identifiant).

   L'appel kill tue donc Bad et Ugly. Par contre, si on fait Ctrl+C,
   cela ne tue que le père et Good. */

int main()
{
	int pg,pb,pu;
	if (!(pg = fork()))
		{ while(1) { sleep(3); printf("good\n"); } }
	else if (!(pb = fork()))
		{ sleep(1); while(1) { sleep(3); printf("bad\n"); } }
	else if (!(pu = fork()))
		{ sleep(2); while(1) { sleep(3); printf("ugly\n"); } }
	else 
	{
		setpgid(pb,pb);
		setpgid(pu,pb);
		printf("type <enter> to kill\n");
		getchar();
		kill(-pb,SIGTERM);
		while(1) { sleep(10); }
	}
}
