#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
     
/* Ce programme utilise un signal d'alarme pour interrompre son activité
   après deux secondes. */

int keep_going = 1;

void catch_alarm (int sig)
{
       keep_going = 0;
}
     
int main (void)
{
	int i = 0;

	/* On établit un gestionnaire pour SIGALRM. */
	/* Attention, usage potentiellement non-portable de signal(2). */
	signal (SIGALRM, catch_alarm);
     
	/* Un signal interviendra dans environ 2 secondes. */
	alarm (2);
     
	/* On boucle jusqu'à ce que le signal arrive. */
	while (keep_going)
	{
		printf ("i = %d\n",++i);
	}
     
       return 0;
}
