#include <signal.h>
#include <stdio.h>
#include <unistd.h>

// Comme ctrlc.c, mais avec un gestionnaire individuel qui ne fait "rien".
// Contrairement à SIG_IGN, la livraison d'un tel signal fait interrompre
// l'appel sleep.

void rien () { }

int main ()
{
	printf("Mon pid est %d.\n",getpid());

	// INT = CTRL-C
	signal(SIGINT,rien);

	// TERM = "kill" dans le terminal
	signal(SIGTERM,rien);

	// KILL: modification impossible
	signal(SIGKILL,rien);

	while (1)
	{
		int x = sleep(3);
		printf("Je suis en vie (et sleep renvoie %d).\n",x);
	}
}
