#include <signal.h>
#include <stdio.h>
#include <unistd.h>

// Ce programme montre comment un processus peut se protéger contre une
// terminaison par Ctrl-C (SIGINT) et d'autres signaux.

int main ()
{
	printf("Mon pid est %d.\n",getpid());

	// INT = CTRL-C
	signal(SIGINT,SIG_IGN);

	// TERM = "kill" dans le terminal
	signal(SIGTERM,SIG_IGN);

	// KILL: modification impossible
	signal(SIGKILL,SIG_IGN);

	while (1)
	{
		sleep(3);
		printf("Je suis en vie...\n");
	}
}
